# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Text-CSV_XS
Version:	1.05
Release:	1.%{__distinit}%{__distvers}
Summary:	Comma-separated values manipulation routines
Group:		Development/Libraries
License:	GPL+ or Artistic
URL:		http://search.cpan.org/dist/Text-CSV_XS/
Source0:	http://search.cpan.org/CPAN/authors/id/H/HM/HMBRAND/Text-CSV_XS-%{version}.tgz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Config)
BuildRequires:	perl(DynaLoader)
BuildRequires:	perl(Encode)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Pod)
BuildRequires:	perl(Test::Pod::Coverage)
BuildRequires:	perl(Tie::Scalar)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Don't "provide" private perl objects
%{?perl_default_filter}

%description
Text::CSV provides facilities for the composition and decomposition of
comma-separated values. An instance of the Text::CSV class can combine
fields into a CSV string and parse a CSV string into fields.

%prep
%setup -q -n Text-CSV_XS-%{version}

# Fix perl location in example scripts
perl -pi -e 's|^#!/pro/bin/perl|#!/usr/bin/perl|' \
	examples/{csv-check,parser-xs.pl,csvdiff,csv2xls,rewrite.pl}
# Turn off exec bits in examples to avoid a multitude of docfile dependencies
chmod -c a-x examples/*

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type f -name '*.bs' -empty -exec rm -f {} ';'
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc ChangeLog README examples/
%{perl_vendorarch}/Text/
%{perl_vendorarch}/auto/Text/
%{_mandir}/man3/Text::CSV_XS.3pm*

%changelog
* Thu Mar 13 2014 Paul Howarth <paul@city-fan.org> - 1.05-1
- Update to 1.05:
  - Allow case insensitive attributes and attribute aliases
    (quote_always = always_quote)
  - Enhanced the csv() function (diagnostics)
  - Start callbacks support
  - Minor doc fixes
  - Make subclassing safer

* Thu Feb  6 2014 Paul Howarth <paul@city-fan.org> - 1.04-1
- Update to 1.04:
  - get_columns() with no argument now returns the empty list instead of undef
    when no columns defined
  - Fragments (rcf7111) now also support AoH (was AoA only)
  - Error code conflict for fragments resolved to 2013
  - New function "csv" (not a method)
- Drop upstreamed done_testing patch

* Fri Jan 24 2014 Paul Howarth <paul@city-fan.org> - 1.03-1
- Update to 1.03:
  - Implement RFC7111
- Patch out the need for Test::More ≥ 0.88

* Mon Nov 11 2013 Paul Howarth <paul@city-fan.org> - 1.02-1
- Update to 1.02:
  - Add example for reading only a single column
  - Don't store NULL in _ERROR_INPUT (CPAN RT#86217)
  - Prevent double-decode in csv-check
  - Add decode_utf8 attribute (default is true)

* Wed Jul 17 2013 Paul Howarth <paul@city-fan.org> - 1.01-2
- Perl 5.18 rebuild

* Mon Jun 17 2013 Paul Howarth <paul@city-fan.org> - 1.01-1
- Update to 1.01:
  - Cache not re-read on getline_all (CPAN RT#86155)

* Thu Jun 13 2013 Paul Howarth <paul@city-fan.org> - 1.00-1
- Update to 1.00:
  - Fix automatic UTF-8 in getline/parse for SV's with \0

* Mon Jun 10 2013 Paul Howarth <paul@city-fan.org> - 0.99-1
- Update to 0.99:
  - If no arguments are passed at all, bind_columns will return the list of
    current bindings or undef if no binds are active

* Mon Jun 10 2013 Paul Howarth <paul@city-fan.org> - 0.98-1
- Update to 0.98:
  - Clarify eol documentation
  - Move error_input to XS

* Sun Mar 31 2013 Paul Howarth <paul@city-fan.org> - 0.97-1
- Update to 0.97:
  - Regain the speed from 0.91 (buffer back to 1k)
  - Minor cleanup in XS code
  - Add diag_verbose attribute

* Wed Mar 27 2013 Paul Howarth <paul@city-fan.org> - 0.96-1
- Update to 0.96:
  - No need to require Test::Harness since it's unused (CPAN RT#82693)
  - parse ("") should return one empty field, not undef
  - Now that we know the record number, show it in auto_diag

* Mon Jan 14 2013 Paul Howarth <paul@city-fan.org> - 0.95-1
- Update to 0.95:
  - Introduce allow_unquoted_escape as workaround for CPAN RT#81295
  - Update copyright to 2013
  - Introduce print_hr() for CPAN RT#76143
  - Dropped plans to support EBCDIC

* Tue Dec  4 2012 Paul Howarth <paul@city-fan.org> - 0.94-1
- Update to 0.94:
  - Guard against beta releases of Encode (CPAN RT#81499)
  - Fix sv_cache init global-buffer-overflow (CPAN RT#81469)
  - Tested with perl compiled with clang (also to verify CPAN RT#81469)
  - Fix memory leak (CPAN RT#81539)

* Mon Nov 19 2012 Paul Howarth <paul@city-fan.org> - 0.93-1
- Update to 0.93:
  - Skip Encode related tests on too old Encode
  - Force old(er) tar format (ustar) - assumes GNU tar on release box
- BR: perl(Encode)

* Tue Nov 13 2012 Paul Howarth <paul@city-fan.org> - 0.92-1
- Update to 0.92:
  - Allow bind_columns() for print()
  - Increase buffer size for print to 64k
  - Fix CPAN RT#80680 - Buffer break halfway through UTF8 characters

* Tue Aug 21 2012 Paul Howarth <paul@city-fan.org> - 0.91-1
- Update to 0.91:
  - Prevent test-failures for long doubles on weird architectures
  - More UTF-8 tests for the change of 0.90
  - Update test case now 5.005 is not supported anymore
  - Rip out the tell/seek introduced in 0.90

* Tue Jul 10 2012 Paul Howarth <paul@city-fan.org> - 0.90-2
- Perl 5.16 rebuild

* Fri Jun 15 2012 Paul Howarth <paul@city-fan.org> - 0.90-1
- Update to 0.90:
  - Drop 5.005 support (5.6.1 is now minimum)
  - Introduce record_number
  - Try harder to get the complete input parsed for the current record when
    hitting errors on parsing seekable IO (only works in 5.14.0 and up)
  - Tested with perl 5.6.1 .. 5.17.0 (99 versions of perl) on Linux, HP-UX,
    AIX, and Windows
  - SvSETMAGIC was missing for tied variables causing weird actions at a
    distance, e.g. in printf
  - UTF8 flag was not always reset when using bound variables

* Fri Mar 16 2012 Paul Howarth <paul@city-fan.org> - 0.88-1
- Update to 0.88:
  - Fix for $/ in 0.86 broke parsing fields that contain excessive $/'s

* Thu Mar  8 2012 Paul Howarth <paul@city-fan.org> - 0.87-1
- Update to 0.87:
  - Extra check on utf8 output (CPAN RT#74330)
  - examples/csvdiff now recognizes numerically sorted CSV files
  - Document example comparing getline_hr vs. bind_columns + getline
- Don't need to remove empty directories from buildroot
- Drop support for distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Sun Jan 22 2012 Paul Howarth <paul@city-fan.org> - 0.86-1
- Update to 0.86:
  - Introduce quote_binary attribute
  - Update copyright to 2012
  - Versions
  - Fixed a utf8::decode on undef (found by perl-5.15.7)
  - Fixed localized $/ interference with other handles (CPAN RT#74216)
- BR: perl(Carp) and perl(DynaLoader)

* Wed Sep  7 2011 Paul Howarth <paul@city-fan.org> - 0.85-1
- Update to 0.85:
  - NAME / DISTNAME in Makefile.PL
  - More cross-checks for META data

* Sun Aug  7 2011 Paul Howarth <paul@city-fan.org> - 0.83-1
- Update to 0.83a:
  - Fix spurious auto_diag warning (CPAN RT#69673)
  - Tested with 50 versions of perl, including 1.15.1

* Thu Jun 23 2011 Paul Howarth <paul@city-fan.org> - 0.82-2
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Sat May  7 2011 Paul Howarth <paul@city-fan.org> - 0.82-1
- Update to 0.82:
  - Documentation fix (CPAN RT#66905)
  - Documentation overhaul (pod links)
- Drop UTF-8 recoding patch, applied upstream

* Wed Mar 23 2011 Paul Howarth <paul@city-fan.org> - 0.81-1
- Update to 0.81:
  - Add is_missing ()
  - Doc overhaul
  - Fix build on OpenVMS (CPAN RT#65654)
  - Fix SetDiag () leak (CPAN RT#66453)
- Recode docs as UTF-8
- Nobody else likes macros for commands

* Sat Dec 25 2010 Paul Howarth <paul@city-fan.org> - 0.80-1
- Update to 0.80:
  - Implement getline_all() and getaline_hr_all()
  - Fixed another parsing issue with eol = \r (CPAN RT#61525)

* Sat Nov 27 2010 Paul Howarth <paul@city-fan.org> - 0.79-1
- Update to 0.79:
  - Version 0.77 broke MacOS exported CSV files with only \r
  - Use correct type for STRLEN (HP-UX/PA-RISC/32)
  - More code coverage
  - EOF unreliable when line-end missing at EOF

* Fri Nov 26 2010 Paul Howarth <paul@city-fan.org> - 0.77-1
- Update to 0.77:
  - Internals now use warn() instead of (void)fprintf (stderr, ...)
  - The test in t/80_diag now passes on Windows
  - Better parsing for eol = \r and set as such (CPAN RT#61525)
  - Workaround for AIX cpp bug (CPAN RT#62388)

* Wed Oct 13 2010 Paul Howarth <paul@city-fan.org> - 0.76-1
- Update to 0.76:
  - Windows doesn't support STDERR redirection as used in t/80_diag

* Fri Oct  8 2010 Paul Howarth <paul@city-fan.org> - 0.75-1
- Update to 0.75:
  - Fixed undefinedness of $\ in print (CPAN RT#61880)

* Thu Sep 30 2010 Paul Howarth <paul@city-fan.org> - 0.74-1
- Update to 0.74:
  - Spelling fixes
  - Real eol support for parsing streams (beyond \n, \r and \r\n)
  - Clarify doc for always_quote to not quote undef fields
  - Clarify UTF8 process for print () and combine ()

* Tue Aug 10 2010 Paul Howarth <paul@city-fan.org> - 0.73-1
- Import from Fedora
- DESTDIR => PERL_INSTALL_ROOT for EL-3 compatibility
- Update to 0.73:
  - Improve date conversion in examples/csv2xls
	new option -D allows column selection for date conversions
  - Tested under perl-5.12.0 (and 21 other versions of perl)
  - Added a note about EBCDIC data files
  - Test suite is now safe for parallel test (prove --shuffle -j6)

* Fri May 07 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.72-2
- Mass rebuild with perl-5.12.0

* Wed Mar 17 2010 Chris Weyl <cweyl@alumni.drew.edu> - 0.72-1
- PERL_INSTALL_ROOT => DESTDIR, add perl_default_filter (XS module)
- Auto-update to 0.72 (by cpan-spec-update 0.01) (DBIx::Class needed a newer
  Text::CSV, which in turn can only leverage Text::CSV_XS >= 0.70)
- Added a new br on perl(ExtUtils::MakeMaker) (version 0)
- Added a new br on perl(IO::Handle) (version 0)
- Added a new br on perl(Test::Harness) (version 0)
- Added a new br on perl(Test::More) (version 0)
- Added a new br on perl(Tie::Scalar) (version 0)

* Fri Dec  4 2009 Stepan Kasal <skasal@redhat.com> - 0.69-2
- Rebuild against perl 5.10.1

* Mon Nov  2 2009 Stepan Kasal <skasal@redhat.com> - 0.69
- New upstream release

* Wed Oct  7 2009 Marcela Mašláňová <mmaslano@redhat.com> - 0.68-1
- Update to new upstream release

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.58-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.58-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Dec 10 2008 Lubomir Rintel <lkundrak@v3.sk> - 0.58-1
- Update to latest upstream
- SvUPGRADE patch upstreamed

* Tue Jul 08 2008 Lubomir Rintel <lkundrak@v3.sk> - 0.52-2
- Actually solving the issue mentioned in previous change

* Tue Jul 08 2008 Lubomir Rintel <lkundrak@v3.sk> - 0.52-1
- Updated to 0.52 to solve an issue with perl 5.10

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.30-5
- Rebuild for perl 5.10 (again)

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.30-4
- Autorebuild for GCC 4.3

* Sat Feb  2 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.30-3
- Rebuild for new perl

* Wed Aug 29 2007 Fedora Release Engineering <rel-eng at fedoraproject dot org> - 0.30-2
- Rebuild for selinux ppc32 issue

* Sat Jun 23 2007 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.30-1
- Update to 0.30

* Sat Jun 16 2007 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.29-1
- Update to 0.29

* Sat Jun 16 2007 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.27-1
- Update to 0.27
- New upstream maintainer

* Thu Sep  7 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.23-5
- Rebuild for FC6

* Wed Feb 22 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.23-4
- Rebuild for FC5 (perl 5.8.8)

* Wed Feb 22 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.23-3
- The wonders of CVS problems (released skipped)

* Thu Jan  5 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.23-2
- Build section: simplified RPM_OPT_FLAGS handling (#175898)

* Sat Nov 05 2005 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.23-1
- First build
